"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const script_1 = require("./script");
const boa = require('@pipcook/boa');
const sys = boa.import('sys');
const createDataset = (dataLoader, metadata) => __awaiter(void 0, void 0, void 0, function* () {
    const rawData = [];
    const rawClass = [];
    const count = yield dataLoader.len();
    for (let i = 0; i < count; i++) {
        const data = yield dataLoader.getItem(i);
        rawData.push(data.data[metadata.feature.names[0]]);
        rawClass.push(data.label);
    }
    return { rawData, rawClass };
});
const bayesianModelEvaluate = (data, model, args) => __awaiter(void 0, void 0, void 0, function* () {
    sys.path.insert(0, path.join(__dirname, 'assets'));
    const { modelDir, expectAccuracy = 0.95 } = args;
    const { testLoader, metadata } = data;
    const filename = path.join(modelDir, 'model.pkl');
    const classifier = yield script_1.loadModel(filename);
    console.log('classify', classifier);
    const { rawData, rawClass } = yield createDataset(testLoader, metadata);
    const text_list = script_1.TextProcessing(rawData, rawClass);
    const feature_words = yield script_1.get_all_words_list(path.join(modelDir, 'feature_words.pkl'));
    const feature_list = script_1.TextFeatures(text_list[1], feature_words);
    const accuracy = classifier.score(feature_list, text_list[2]);
    return {
        pass: accuracy >= parseInt(expectAccuracy),
        accuracy
    };
});
exports.default = bayesianModelEvaluate;
//# sourceMappingURL=index.js.map